//filename: main.cpp

#include <windows.h>
#include <stdlib.h>
#include <wtypes.h>
#include <conio.h>
#include <stdio.h>
#include "main.h"


BOOLEAN LoadLibraries()
{
	hLib301 = LoadLibrary ("LL_USB2k.dll");
    if(!hLib301) return FALSE;
    return TRUE;
}

BOOLEAN InitLibFuncs()
{  
	EX_Connect = (P_DLL_EX_CONNECT)GetProcAddress(hLib301, "EX_Connect");
	if(!EX_Connect) return FALSE;
	EX_SetScanType =  (P_DLL_EX_SET_SCAN_TYPE)GetProcAddress(hLib301, "EX_SetScanType");
	if(!EX_SetScanType) return FALSE;
	EX_SetMultiChanScanChans =  (P_DLL_EX_SET_MULTI_CHAN_SCAN_CHANS)GetProcAddress(hLib301, "EX_SetMultiChanScanChans");
	if(!EX_SetMultiChanScanChans) return FALSE;
	EX_SetMultiChanScanChans_TO_LOG =  (P_DLL_EX_SET_MULTI_CHAN_SCAN_LOG_CHANS)GetProcAddress(hLib301, "EX_SetMultiChanScanChans_TO_LOG");
	if(!EX_SetMultiChanScanChans_TO_LOG) return FALSE;
	EX_Run = (P_DLL_EX_RUN)GetProcAddress(hLib301, "EX_Run");
	if(!EX_Run) return FALSE;
	EX_Stop = (P_DLL_EX_STOP)GetProcAddress(hLib301, "EX_Stop");
	if(!EX_Stop) return FALSE;
	EX_StopComplete = (P_DLL_EX_STOP_COMPLETE)GetProcAddress(hLib301, "EX_StopComplete");
	if(!EX_StopComplete) return FALSE;

    return TRUE;
}


int __cdecl main()
{
	USHORT usDevID = 0; 
	BOOLEAN fRetVal = FALSE; BOOLEAN fRunning = FALSE; BOOLEAN fRedraw = FALSE;

	if(!LoadLibraries()){ printf("Failed to load libraries"); getch(); return 0;}
	printf("Success loading libraries\n");

	if(!InitLibFuncs())
	{ printf("Failed to find required functions"); getch(); return 0;}

	printf("Success finding required functions\nConnecting -  please wait. . .");
	fRetVal = EX_Connect(&usDevID);
	if(!(fRetVal | usDevID))
	{ printf("Failed  EX_Connect()"); getch(); return 0; }

	char cUserInputVal = NULL; char szOutVal[32], szTempBuff[32]; int iKeyChar = 0;  

	while(true)
	{
		setMainScreen();
		fRedraw = FALSE;

		while((cUserInputVal != 'Q') && (cUserInputVal != 'q') && (cUserInputVal != 27) && (!fRedraw))
		{
			sprintf(szOutVal, ""); 
			cUserInputVal = (char)getch();
			switch(cUserInputVal)
			{
				case 'Q': case 'q': case 27:
					printf("\nDisconnecting and exiting, please wait ....\n"); break;
				case 'R': case 'r':
					fRedraw = TRUE; system("cls"); break;
				case 'S': case 's':
					if(!fRunning)
					{
						if((!EX_SetScanType (usDevID, MULTI_CHAN_CAL_DIGIN_SCAN)) 
							|| (!EX_SetMultiChanScanChans (usDevID, 8)) 
							|| (!EX_Run(usDevID))
							) 
						{ printf("\nfailed to start scan run\n"); }

						else
						{ printf("\nScan running. Data being logged to disk file\n\tPress 'E' to end run\n"); fRunning = TRUE; }
					}
					else printf("Already running - Press 'E' to stop\n"); break;
				case 'E': case 'e':
					if(fRunning)
					{
						if(!EX_Stop(usDevID)) printf("\nfailed to stop scan run\n"); 
						else
						{ EX_StopComplete(usDevID); printf("\nScan Stopped.\n"); fRunning = FALSE; }
					}
					else printf("Already Stopped - Press 'S' to start scan run\n"); break;
				case 'M': case 'm':
					sprintf(szOutVal, ""); printf("\nenter channel log mask: ");
					while(TRUE)
					{
						// take care of backspaces and non-numerics
						if(((iKeyChar == 8) || (iKeyChar < 48) || (iKeyChar > 57)) && (strlen(szOutVal) > 0)) 
						{
							setMainScreen(); if(iKeyChar == 8) szOutVal[strlen(szOutVal)-1] = 0; 
							printf("\nenter channel log mask: %s", szOutVal);
							continue;
						}
						iKeyChar = getche(); if(iKeyChar == 13) break;
						sprintf(szTempBuff, "%u", ((BYTE)iKeyChar) - '0');
						strcat(szOutVal, szTempBuff); if(strlen(szOutVal) == 3) break;
					}
					
					if(((UINT)(atoi(szOutVal))) > 255)
					{ printf("\nvalue entered greater than 255. New value: 255 (all channel logging)"); sprintf(szOutVal, "255"); }
					BYTE bLogChans = (BYTE)(atoi(szOutVal));
					if(!EX_SetMultiChanScanChans_TO_LOG (usDevID, bLogChans)) printf("\nfailed to set data log channels\n"); 
					else printf("\ndata log mask  %d  sent\n", (BYTE)(atoi(szOutVal)));
					sprintf(szOutVal, ""); break;
			}
		}
		if(!fRedraw) break;
	}

	return 1;
}
void setMainScreen(void)
{
	system("cls");
	printf("\nINITIALIZED\n"
		"About the data-log channel mask usage:\n"
		" The option requires a bit-mask representing the channels to log.\n"
		" For example 80 (binary 10000000) indicates logging of only channel 7,\n"
		"   255 (binary 11111111) indicates logging of all channels, \n"
		"   85 (binary 1010101) indicates logging channels 0,2,4, and 6.\n\n"
		"Press one of the following keys:\n"
		"'Q' quit\n"
		"'R' redraw screen\n"
		"'M' set data-log channels\n"
		"'S' start scanning\n"
		"'E' end scanning\n"
		);
}

